# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class PipelineScheduledRunApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_pipeline(self, , **kwargs):  # noqa: E501
        """delete pipeline-runs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_pipeline(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_pipeline_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_pipeline_with_http_info(, **kwargs)  # noqa: E501
            return data

    def delete_pipeline_with_http_info(self, , **kwargs):  # noqa: E501
        """delete pipeline-runs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_pipeline_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_pipeline" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `delete_pipeline`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['pipelineScheduleRunId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/pipeline-scheduled-runs/{pipelineScheduledRunId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def disable_pipeline_scheduled_run(self, , **kwargs):  # noqa: E501
        """disable pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.disable_pipeline_scheduled_run(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.disable_pipeline_scheduled_run_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.disable_pipeline_scheduled_run_with_http_info(, **kwargs)  # noqa: E501
            return data

    def disable_pipeline_scheduled_run_with_http_info(self, , **kwargs):  # noqa: E501
        """disable pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.disable_pipeline_scheduled_run_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method disable_pipeline_scheduled_run" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `disable_pipeline_scheduled_run`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['pipelineScheduleRunId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/pipeline-scheduled-runs/{pipelineScheduleRunId}/disable', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DefinitionspipelineRun',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def enable_pipeline_scheduled_run(self, , **kwargs):  # noqa: E501
        """enable pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.enable_pipeline_scheduled_run(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.enable_pipeline_scheduled_run_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.enable_pipeline_scheduled_run_with_http_info(, **kwargs)  # noqa: E501
            return data

    def enable_pipeline_scheduled_run_with_http_info(self, , **kwargs):  # noqa: E501
        """enable pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.enable_pipeline_scheduled_run_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method enable_pipeline_scheduled_run" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `enable_pipeline_scheduled_run`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['pipelineScheduleRunId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/pipeline-scheduled-runs/{pipelineScheduleRunId}/enable', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DefinitionspipelineRun',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_pipeline_schedule_run(self, , **kwargs):  # noqa: E501
        """get pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_pipeline_schedule_run(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :param  : Number of paginated elements
        :param  : Token to access a specific page, if not provided, the result served will be the first page
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_pipeline_schedule_run_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.get_pipeline_schedule_run_with_http_info(, **kwargs)  # noqa: E501
            return data

    def get_pipeline_schedule_run_with_http_info(self, , **kwargs):  # noqa: E501
        """get pipeline-run  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_pipeline_schedule_run_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :param  : Number of paginated elements
        :param  : Token to access a specific page, if not provided, the result served will be the first page
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['', '', '']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_pipeline_schedule_run" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `get_pipeline_schedule_run`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['pipelineScheduleRunId'] = params['']  # noqa: E501

        query_params = []
        if '' in params:
            query_params.append(('limit', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('pageToken', params['']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/pipeline-scheduled-runs/{pipelineScheduledRunId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DefinitionspipelineRun',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_pipeline_schedule_runs(self, , **kwargs):  # noqa: E501
        """get pipeline runs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_pipeline_schedule_runs(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_pipeline_schedule_runs_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.get_pipeline_schedule_runs_with_http_info(, **kwargs)  # noqa: E501
            return data

    def get_pipeline_schedule_runs_with_http_info(self, , **kwargs):  # noqa: E501
        """get pipeline runs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_pipeline_schedule_runs_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of pipeline-run to return (required)
        :return: DefinitionspipelineRun
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_pipeline_schedule_runs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `get_pipeline_schedule_runs`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['pipelineScheduleRunId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/pipeline-scheduled-runs/{pipelineScheduledRunId}/runs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DefinitionspipelineRun',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
